(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ss-dynamic-forms/core'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap/timepicker'), require('@angular/common'), require('ngx-bootstrap/rating'), require('angular2-text-mask')) :
    typeof define === 'function' && define.amd ? define('@ss-dynamic-forms/ui-bootstrap', ['exports', '@angular/core', '@angular/forms', '@ss-dynamic-forms/core', 'ngx-bootstrap/datepicker', 'ngx-bootstrap/timepicker', '@angular/common', 'ngx-bootstrap/rating', 'angular2-text-mask'], factory) :
    (global = global || self, factory((global.ngDynamicForms = global.ngDynamicForms || {}, global.ngDynamicForms.ui = global.ngDynamicForms.ui || {}, global.ngDynamicForms.ui.bootstrap = {}), global.ng.core, global.ng.forms, global.ngDynamicForms.core, global['ngx-bootstrap'].datepicker, global['ngx-bootstrap'].timepicker, global.ng.common, global['ngx-bootstrap'].rating, global['angular2-text-mask']));
}(this, (function (exports, core, forms, core$1, datepicker, timepicker, common, rating, angular2TextMask) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/checkbox/dynamic-bootstrap-checkbox.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapCheckboxComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapCheckboxComponent, _super);
        function DynamicBootstrapCheckboxComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapCheckboxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-checkbox",
                        template: "<div [formGroup]=\"group\" [class.disabled]=\"model.disabled\" [ngClass]=\"getClass('element', 'control') || 'checkbox'\">\n\n    <label>\n\n        <input type=\"checkbox\"\n               [checked]=\"model.checked\"\n               [formControlName]=\"model.id\"\n               [id]=\"elementId\"\n               [indeterminate]=\"model.indeterminate\"\n               [name]=\"model.name\"\n               [ngClass]=\"getClass('element', 'control')\"\n               [required]=\"model.required\"\n               [tabindex]=\"model.tabIndex\"\n               [value]=\"model.value\"\n               (blur)=\"onBlur($event)\"\n               (change)=\"onChange($event)\"\n               (focus)=\"onFocus($event)\"/><span [innerHTML]=\"model.label\"\n                                                [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></span></label>\n</div>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapCheckboxComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapCheckboxComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapCheckboxComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapCheckboxComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapCheckboxComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapCheckboxComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapCheckboxComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapCheckboxComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapCheckboxComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapCheckboxComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapCheckboxComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/datepicker/dynamic-bootstrap-datepicker.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapDatePickerComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapDatePickerComponent, _super);
        function DynamicBootstrapDatePickerComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapDatePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-datepicker",
                        template: "<div [formGroup]=\"group\" class=\"input-group\">\n\n    <input bsDatepicker class=\"form-control\" #bsDatepicker=\"bsDatepicker\"\n           [autofocus]=\"model.autoFocus\"\n           [bsConfig]=\"model.getAdditional('bsConfig', {containerClass: model.getAdditional('containerClass', 'theme-green'), showWeekNumbers: model.getAdditional('showWeekNumbers', true)})\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [maxDate]=\"model.max\"\n           [minDate]=\"model.min\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [outsideClick]=\"model.getAdditional('outsideClick', true)\"\n           [placeholder]=\"model.placeholder\"\n           [placement]=\"model.getAdditional('placement', 'bottom')\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           (bsValueChange)=\"onChange($event)\"\n           (onHidden)=\"onCustomEvent($event, 'onHidden')\"\n           (onShown)=\"onCustomEvent($event, 'onShown')\">\n\n    <div *ngIf=\"model.toggleLabel\" class=\"input-group-btn\">\n\n        <button *ngIf=\"model.toggleIcon\" class=\"btn\" (click)=\"bsDatepicker.toggle()\"><img [src]=\"model.toggleIcon\"/></button>\n        <button *ngIf=\"model.toggleLabel\" class=\"btn\" (click)=\"bsDatepicker.toggle()\">{{ model.toggleLabel }}</button>\n\n    </div>\n\n</div>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapDatePickerComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapDatePickerComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            bsDatePicker: [{ type: core.ViewChild, args: [datepicker.BsDatepickerDirective, { static: true },] }]
        };
        return DynamicBootstrapDatePickerComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.customEvent;
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.focus;
        /** @type {?} */
        DynamicBootstrapDatePickerComponent.prototype.bsDatePicker;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapDatePickerComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapDatePickerComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-array/dynamic-bootstrap-form-array.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapFormArrayComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapFormArrayComponent, _super);
        function DynamicBootstrapFormArrayComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapFormArrayComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-form-array",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <div [formArrayName]=\"model.id\" [id]=\"elementId\" [ngClass]=\"getClass('element', 'control')\">\n\n        <div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\"\n             [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\">\n\n            <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: groupModel\"></ng-container>\n\n            <dynamic-bootstrap-form-control *ngFor=\"let _model of groupModel.group\"\n                                            [context]=\"groupModel\"\n                                            [group]=\"array.at(idx)\"\n                                            [hidden]=\"_model.hidden\"\n                                            [layout]=\"layout\"\n                                            [model]=\"_model\"\n                                            [templates]=\"templates\"\n                                            [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                        getClass('element','children'), getClass('grid','children')]\"\n                                            (blur)=\"onBlur($event)\"\n                                            (change)=\"onChange($event)\"\n                                            (focus)=\"onFocus($event)\"\n                                            (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-bootstrap-form-control>\n\n            <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: groupModel\"></ng-container>\n\n        </div>\n\n    </div>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapFormArrayComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapFormArrayComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            templates: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapFormArrayComponent;
    }(core$1.DynamicFormArrayComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.templates;
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.customEvent;
        /** @type {?} */
        DynamicBootstrapFormArrayComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormArrayComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormArrayComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-group/dynamic-bootstrap-form-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapFormGroupComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapFormGroupComponent, _super);
        function DynamicBootstrapFormGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapFormGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-form-group",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <fieldset [formGroupName]=\"model.id\"\n              [id]=\"elementId\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\">\n\n        <legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend>\n\n        <dynamic-bootstrap-form-control *ngFor=\"let _model of model.group\"\n                                        [asBootstrapFormGroup]=\"false\"\n                                        [group]=\"control\"\n                                        [hidden]=\"_model.hidden\"\n                                        [layout]=\"layout\"\n                                        [model]=\"_model\"\n                                        [templates]=\"templates\"\n                                        [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                    getClass('element','children'), getClass('grid','children')]\"\n                                        (blur)=\"onBlur($event)\"\n                                        (change)=\"onChange($event)\"\n                                        (focus)=\"onFocus($event)\"\n                                        (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-bootstrap-form-control>\n    </fieldset>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapFormGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapFormGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            templates: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapFormGroupComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.templates;
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.customEvent;
        /** @type {?} */
        DynamicBootstrapFormGroupComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormGroupComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormGroupComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/input/dynamic-bootstrap-input.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapInputComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapInputComponent, _super);
        function DynamicBootstrapInputComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapInputComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-input",
                        template: "<div [formGroup]=\"group\" [class.input-group]=\"model.prefix || model.suffix\">\n\n    <div *ngIf=\"model.prefix\" class=\"input-group-addon\" [innerHTML]=\"model.prefix\"></div>\n\n    <input class=\"form-control\"\n           [attr.accept]=\"model.accept\"\n           [attr.max]=\"model.max\"\n           [attr.min]=\"model.min\"\n           [attr.multiple]=\"model.multiple\"\n           [attr.step]=\"model.step\"\n           [autocomplete]=\"model.autoComplete\"\n           [autofocus]=\"model.autoFocus\"\n           [dynamicList]=\"model.listId\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [maxlength]=\"model.maxLength\"\n           [minlength]=\"model.minLength\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [pattern]=\"model.pattern\"\n           [placeholder]=\"model.placeholder\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           [spellcheck]=\"model.spellCheck\"\n           [tabindex]=\"model.tabIndex\"\n           [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\"\n           [type]=\"model.inputType\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/>\n\n    <div *ngIf=\"model.suffix\" class=\"input-group-addon\" [innerHTML]=\"model.suffix\"></div>\n\n    <datalist *ngIf=\"model.hasList\" [id]=\"model.listId\">\n\n        <option *ngFor=\"let option of model.list$ | async\" [value]=\"option\">\n\n    </datalist>\n\n</div>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapInputComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapInputComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapInputComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapInputComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapInputComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapInputComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapInputComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapInputComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapInputComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapInputComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapInputComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/radio-group/dynamic-bootstrap-radio-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapRadioGroupComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapRadioGroupComponent, _super);
        function DynamicBootstrapRadioGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapRadioGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-radio-group",
                        template: "<fieldset role=\"radiogroup\"\n          [formGroup]=\"group\"\n          [id]=\"elementId\"\n          [name]=\"model.name\"\n          [ngClass]=\"getClass('element', 'control')\"\n          [tabindex]=\"model.tabIndex\"\n          (change)=\"onChange($event)\">\n\n    <legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend>\n\n    <div *ngFor=\"let option of model.options$ | async\" [ngClass]=\"getClass('element', 'option') || 'radio'\">\n\n        <label><input type=\"radio\"\n                      [formControlName]=\"model.id\"\n                      [name]=\"model.name\"\n                      [value]=\"option.value\"\n                      (blur)=\"onBlur($event)\"\n                      (focus)=\"onFocus($event)\"/><span [innerHTML]=\"option.label\"></span></label>\n    </div>\n\n</fieldset>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapRadioGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapRadioGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapRadioGroupComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapRadioGroupComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapRadioGroupComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapRadioGroupComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapRadioGroupComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapRadioGroupComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapRadioGroupComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapRadioGroupComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapRadioGroupComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/rating/dynamic-bootstrap-rating.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapRatingComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapRatingComponent, _super);
        function DynamicBootstrapRatingComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapRatingComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-rating",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <rating [formControlName]=\"model.id\"\n            [id]=\"elementId\"\n            [max]=\"model.max\"\n            [ngClass]=\"getClass('element', 'control')\"\n            [readonly]=\"model.getAdditional('readonly', false)\"\n            (onHover)=\"onCustomEvent($event, 'onHover')\"\n            (onLeave)=\"onCustomEvent($event, 'onLeave')\"></rating>\n\n</ng-container>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapRatingComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapRatingComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapRatingComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapRatingComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapRatingComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapRatingComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapRatingComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapRatingComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapRatingComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapRatingComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapRatingComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/select/dynamic-bootstrap-select.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapSelectComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapSelectComponent, _super);
        function DynamicBootstrapSelectComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapSelectComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-select",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <select class=\"form-control\"\n            [compareWith]=\"model.compareWithFn\"\n            [formControlName]=\"model.id\"\n            [id]=\"elementId\"\n            [name]=\"model.name\"\n            [ngClass]=\"getClass('element', 'control')\"\n            [required]=\"model.required\"\n            [tabindex]=\"model.tabIndex\"\n            (blur)=\"onBlur($event)\"\n            (change)=\"onChange($event)\"\n            (focus)=\"onFocus($event)\">\n\n        <option *ngFor=\"let option of model.options$ | async\"\n                [disabled]=\"option.disabled\"\n                [ngValue]=\"option.value\">{{ option.label }}\n        </option>\n\n    </select>\n\n</ng-container>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapSelectComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapSelectComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapSelectComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapSelectComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapSelectComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapSelectComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapSelectComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapSelectComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapSelectComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapSelectComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapSelectComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/textarea/dynamic-bootstrap-textarea.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapTextAreaComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapTextAreaComponent, _super);
        function DynamicBootstrapTextAreaComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapTextAreaComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-textarea",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <textarea class=\"form-control\"\n              [cols]=\"model.cols\"\n              [formControlName]=\"elementId\"\n              [id]=\"elementId\"\n              [maxlength]=\"model.maxLength\"\n              [minlength]=\"model.minLength\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\"\n              [placeholder]=\"model.placeholder\"\n              [readonly]=\"model.readOnly\"\n              [required]=\"model.required\"\n              [rows]=\"model.rows\"\n              [spellcheck]=\"model.spellCheck\"\n              [tabindex]=\"model.tabIndex\"\n              [wrap]=\"model.wrap\"\n              (blur)=\"onBlur($event)\"\n              (change)=\"onChange($event)\"\n              (focus)=\"onFocus($event)\"></textarea>\n\n</ng-container>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapTextAreaComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapTextAreaComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBootstrapTextAreaComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapTextAreaComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapTextAreaComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapTextAreaComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapTextAreaComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapTextAreaComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapTextAreaComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapTextAreaComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapTextAreaComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/timepicker/dynamic-bootstrap-timepicker.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapTimePickerComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapTimePickerComponent, _super);
        function DynamicBootstrapTimePickerComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapTimePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-timepicker",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <timepicker [arrowkeys]=\"model.getAdditional('arrowkeys', true)\"\n                [formControlName]=\"model.id\"\n                [hourStep]=\"model.getAdditional('hourStep', 1)\"\n                [id]=\"elementId\"\n                [max]=\"model.max\"\n                [min]=\"model.min\"\n                [mousewheel]=\"model.getAdditional('mousewheel', true)\"\n                [minuteStep]=\"model.getAdditional('minuteStep', 1)\"\n                [ngClass]=\"getClass('element', 'control')\"\n                [secondsStep]=\"model.getAdditional('secondsStep', 1)\"\n                [showMeridian]=\"model.meridian\"\n                [showSeconds]=\"model.showSeconds\"\n                [showSpinners]=\"model.getAdditional('spinners', true)\"></timepicker>\n\n</ng-container>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapTimePickerComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBootstrapTimePickerComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            bsTimePicker: [{ type: core.ViewChild, args: [timepicker.TimepickerComponent, { static: true },] }]
        };
        return DynamicBootstrapTimePickerComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapTimePickerComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapTimePickerComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapTimePickerComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapTimePickerComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapTimePickerComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapTimePickerComponent.prototype.focus;
        /** @type {?} */
        DynamicBootstrapTimePickerComponent.prototype.bsTimePicker;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapTimePickerComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapTimePickerComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/dynamic-bootstrap-form-control-container.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapFormControlContainerComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapFormControlContainerComponent, _super);
        function DynamicBootstrapFormControlContainerComponent(componentFactoryResolver, layoutService, validationService, componentService, relationService) {
            var _this = _super.call(this, componentFactoryResolver, layoutService, validationService, componentService, relationService) || this;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.componentService = componentService;
            _this.relationService = relationService;
            _this.asBootstrapFormGroup = true;
            _this.context = null;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(DynamicBootstrapFormControlContainerComponent.prototype, "componentType", {
            get: /**
             * @return {?}
             */
            function () {
                return this.componentService.getCustomComponentType(this.model) || bootstrapUIFormControlMapFn(this.model);
            },
            enumerable: true,
            configurable: true
        });
        DynamicBootstrapFormControlContainerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-form-control",
                        template: "<div [class.form-group]=\"asBootstrapFormGroup || getClass('element', 'container').includes('form-group')\"\n     [class.has-error]=\"showErrorMessages\"\n     [formGroup]=\"group\"\n     [ngClass]=\"['ss-dynamic-forms-'+model.type.toLowerCase(), getClass('element', 'container'), getClass('grid', 'container')]\">\n\n    <label *ngIf=\"!isCheckbox && hasLabel\"\n           [for]=\"elementId\"\n           [innerHTML]=\"model.label\"\n           [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></label>\n\n    <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: model\"></ng-container>\n\n    <div [ngClass]=\"getClass('grid', 'control')\">\n\n        <ng-container #componentViewContainer></ng-container>\n\n        <span *ngIf=\"hasHint\" class=\"help-block\" [innerHTML]=\"hint\"\n              [ngClass]=\"getClass('element', 'hint')\"></span>\n\n    </div>\n\n    <ul *ngIf=\"showErrorMessages\" class=\"has-error\"\n        [ngClass]=\"[getClass('element', 'errors'), getClass('grid', 'errors')]\">\n\n        <li *ngFor=\"let message of errorMessages\" class=\"help-block\">{{ message }}</li>\n\n    </ul>\n\n    <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: model\"></ng-container>\n\n    <ng-content></ng-content>\n\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapFormControlContainerComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService },
            { type: core$1.DynamicFormComponentService },
            { type: core$1.DynamicFormRelationService }
        ]; };
        DynamicBootstrapFormControlContainerComponent.propDecorators = {
            contentTemplateList: [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] }],
            inputTemplateList: [{ type: core.Input, args: ["templates",] }],
            asBootstrapFormGroup: [{ type: core.Input }],
            context: [{ type: core.Input }],
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            customEvent: [{ type: core.Output, args: ["bsEvent",] }],
            componentViewContainerRef: [{ type: core.ViewChild, args: ["componentViewContainer", { read: core.ViewContainerRef, static: true },] }]
        };
        return DynamicBootstrapFormControlContainerComponent;
    }(core$1.DynamicFormControlContainerComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.contentTemplateList;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.inputTemplateList;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.asBootstrapFormGroup;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.context;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.group;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.layout;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.model;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.focus;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.customEvent;
        /** @type {?} */
        DynamicBootstrapFormControlContainerComponent.prototype.componentViewContainerRef;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormControlContainerComponent.prototype.componentFactoryResolver;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormControlContainerComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormControlContainerComponent.prototype.validationService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormControlContainerComponent.prototype.componentService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormControlContainerComponent.prototype.relationService;
    }
    /**
     * @param {?} model
     * @return {?}
     */
    function bootstrapUIFormControlMapFn(model) {
        switch (model.type) {
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return DynamicBootstrapFormArrayComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return DynamicBootstrapCheckboxComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
                return DynamicBootstrapFormGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return DynamicBootstrapDatePickerComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return DynamicBootstrapFormGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return DynamicBootstrapInputComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return DynamicBootstrapRadioGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RATING:
                return DynamicBootstrapRatingComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return DynamicBootstrapSelectComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return DynamicBootstrapTextAreaComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TIMEPICKER:
                return DynamicBootstrapTimePickerComponent;
            default:
                return null;
        }
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/dynamic-bootstrap-form.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBootstrapFormComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapFormComponent, _super);
        function DynamicBootstrapFormComponent(formService, layoutService) {
            var _this = _super.call(this, formService, layoutService) || this;
            _this.formService = formService;
            _this.layoutService = layoutService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-form",
                        template: "<dynamic-bootstrap-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\"\n                                [group]=\"formGroup\"\n                                [hidden]=\"model.hidden\"\n                                [layout]=\"formLayout\"\n                                [model]=\"model\"\n                                [ngClass]=\"[getClass(model,'element','host'), getClass(model,'grid','host')]\"\n                                [templates]=\"templates\"\n                                (blur)=\"onEvent($event, 'blur')\"\n                                (change)=\"onEvent($event, 'change')\"\n                                (focus)=\"onEvent($event, 'focus')\"\n                                (bsEvent)=\"onEvent($event, 'custom')\"></dynamic-bootstrap-form-control>"
                    }] }
        ];
        /** @nocollapse */
        DynamicBootstrapFormComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormService },
            { type: core$1.DynamicFormLayoutService }
        ]; };
        DynamicBootstrapFormComponent.propDecorators = {
            formGroup: [{ type: core.Input, args: ["group",] }],
            formModel: [{ type: core.Input, args: ["model",] }],
            formLayout: [{ type: core.Input, args: ["layout",] }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            customEvent: [{ type: core.Output, args: ["bsEvent",] }],
            templates: [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] }],
            components: [{ type: core.ViewChildren, args: [DynamicBootstrapFormControlContainerComponent,] }]
        };
        return DynamicBootstrapFormComponent;
    }(core$1.DynamicFormComponent));
    if (false) {
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.formGroup;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.formModel;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.formLayout;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.blur;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.change;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.focus;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.customEvent;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.templates;
        /** @type {?} */
        DynamicBootstrapFormComponent.prototype.components;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormComponent.prototype.formService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBootstrapFormComponent.prototype.layoutService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/dynamic-bootstrap-form-ui.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicFormsBootstrapUIModule = /** @class */ (function () {
        function DynamicFormsBootstrapUIModule() {
        }
        DynamicFormsBootstrapUIModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            datepicker.BsDatepickerModule,
                            rating.RatingModule,
                            timepicker.TimepickerModule,
                            angular2TextMask.TextMaskModule,
                            core$1.DynamicFormsCoreModule
                        ],
                        declarations: [
                            DynamicBootstrapCheckboxComponent,
                            DynamicBootstrapDatePickerComponent,
                            DynamicBootstrapFormArrayComponent,
                            DynamicBootstrapFormComponent,
                            DynamicBootstrapFormControlContainerComponent,
                            DynamicBootstrapFormGroupComponent,
                            DynamicBootstrapInputComponent,
                            DynamicBootstrapRadioGroupComponent,
                            DynamicBootstrapRatingComponent,
                            DynamicBootstrapSelectComponent,
                            DynamicBootstrapTextAreaComponent,
                            DynamicBootstrapTimePickerComponent
                        ],
                        entryComponents: [
                            DynamicBootstrapCheckboxComponent,
                            DynamicBootstrapDatePickerComponent,
                            DynamicBootstrapFormArrayComponent,
                            DynamicBootstrapFormGroupComponent,
                            DynamicBootstrapInputComponent,
                            DynamicBootstrapRadioGroupComponent,
                            DynamicBootstrapRatingComponent,
                            DynamicBootstrapSelectComponent,
                            DynamicBootstrapTextAreaComponent,
                            DynamicBootstrapTimePickerComponent
                        ],
                        exports: [
                            core$1.DynamicFormsCoreModule,
                            DynamicBootstrapCheckboxComponent,
                            DynamicBootstrapDatePickerComponent,
                            DynamicBootstrapFormArrayComponent,
                            DynamicBootstrapFormComponent,
                            DynamicBootstrapFormControlContainerComponent,
                            DynamicBootstrapFormGroupComponent,
                            DynamicBootstrapInputComponent,
                            DynamicBootstrapRadioGroupComponent,
                            DynamicBootstrapRatingComponent,
                            DynamicBootstrapSelectComponent,
                            DynamicBootstrapTextAreaComponent,
                            DynamicBootstrapTimePickerComponent
                        ]
                    },] }
        ];
        return DynamicFormsBootstrapUIModule;
    }());

    exports.DynamicBootstrapCheckboxComponent = DynamicBootstrapCheckboxComponent;
    exports.DynamicBootstrapDatePickerComponent = DynamicBootstrapDatePickerComponent;
    exports.DynamicBootstrapFormArrayComponent = DynamicBootstrapFormArrayComponent;
    exports.DynamicBootstrapFormComponent = DynamicBootstrapFormComponent;
    exports.DynamicBootstrapFormControlContainerComponent = DynamicBootstrapFormControlContainerComponent;
    exports.DynamicBootstrapFormGroupComponent = DynamicBootstrapFormGroupComponent;
    exports.DynamicBootstrapInputComponent = DynamicBootstrapInputComponent;
    exports.DynamicBootstrapRadioGroupComponent = DynamicBootstrapRadioGroupComponent;
    exports.DynamicBootstrapRatingComponent = DynamicBootstrapRatingComponent;
    exports.DynamicBootstrapSelectComponent = DynamicBootstrapSelectComponent;
    exports.DynamicBootstrapTextAreaComponent = DynamicBootstrapTextAreaComponent;
    exports.DynamicBootstrapTimePickerComponent = DynamicBootstrapTimePickerComponent;
    exports.DynamicFormsBootstrapUIModule = DynamicFormsBootstrapUIModule;
    exports.bootstrapUIFormControlMapFn = bootstrapUIFormControlMapFn;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ui-bootstrap.umd.js.map
